/* This file is autogenerated by lp_tile_soa.py from u_format.csv. Do not edit directly. */

/**************************************************************************
 *
 * Copyright 2009 VMware, Inc.
 * All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sub license, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT.
 * IN NO EVENT SHALL VMWARE AND/OR ITS SUPPLIERS BE LIABLE FOR
 * ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 **************************************************************************/

/**
 * @file
 * Pixel format accessor functions.
 *
 * @author Jose Fonseca <jfonseca@vmware.com>
 */

#include "pipe/p_compiler.h"
#include "util/u_format.h"
#include "util/u_math.h"
#include "lp_tile_soa.h"

const unsigned char
tile_offset[TILE_VECTOR_HEIGHT][TILE_VECTOR_WIDTH] = {
   {  0,  1,  4,  5},
   {  2,  3,  6,  7},
   {  8,  9, 12, 13},
   { 10, 11, 14, 15}
};

/* Note: these lookup tables could be replaced with some
 * bit-twiddling code, but this is a little faster.
 */
static unsigned tile_x_offset[TILE_VECTOR_WIDTH * TILE_VECTOR_HEIGHT] = {
   0, 1, 0, 1, 2, 3, 2, 3,
   0, 1, 0, 1, 2, 3, 2, 3
};

static unsigned tile_y_offset[TILE_VECTOR_WIDTH * TILE_VECTOR_HEIGHT] = {
   0, 0, 1, 1, 0, 0, 1, 1,
   2, 2, 3, 3, 2, 2, 3, 3
};

static INLINE double
clamp(double value, double lbound, double ubound)
{
   if(value < lbound)
      return lbound;
   if(value > ubound)
      return ubound;
   return value;
}

static INLINE float
clampf(float value, float lbound, float ubound)
{
   if(value < lbound)
      return lbound;
   if(value > ubound)
      return ubound;
   return value;
}

static INLINE unsigned int
clampui(unsigned int value, unsigned int lbound, unsigned int ubound)
{
   if(value < lbound)
      return lbound;
   if(value > ubound)
      return ubound;
   return value;
}

static INLINE int
clampsi(int value, int lbound, int ubound)
{
   if(value < lbound)
      return lbound;
   if(value > ubound)
      return ubound;
   return value;
}

static void
lp_tile_b8g8r8a8_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint8_t *src_pixel = (const uint8_t *)(src_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint8_t b = (*src_pixel++);
         uint8_t g = (*src_pixel++);
         uint8_t r = (*src_pixel++);
         uint8_t a = (*src_pixel++);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = a; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_b8g8r8x8_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint8_t *src_pixel = (const uint8_t *)(src_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint8_t b = (*src_pixel++);
         uint8_t g = (*src_pixel++);
         uint8_t r = (*src_pixel++);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_a8r8g8b8_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint8_t *src_pixel = (const uint8_t *)(src_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint8_t a = (*src_pixel++);
         uint8_t r = (*src_pixel++);
         uint8_t g = (*src_pixel++);
         uint8_t b = (*src_pixel++);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = a; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_x8r8g8b8_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint8_t *src_pixel = (const uint8_t *)(src_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint8_t r = (*src_pixel++);
         uint8_t g = (*src_pixel++);
         uint8_t b = (*src_pixel++);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_a8b8g8r8_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint8_t *src_pixel = (const uint8_t *)(src_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint8_t a = (*src_pixel++);
         uint8_t b = (*src_pixel++);
         uint8_t g = (*src_pixel++);
         uint8_t r = (*src_pixel++);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = a; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_x8b8g8r8_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint8_t *src_pixel = (const uint8_t *)(src_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint8_t b = (*src_pixel++);
         uint8_t g = (*src_pixel++);
         uint8_t r = (*src_pixel++);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_b5g5r5a1_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint16_t *src_pixel = (const uint16_t *)(src_row + x0*2);
      for (x = 0; x < w; ++x) {
         uint16_t pixel = *src_pixel++;
         uint8_t b = (uint8_t)((uint32_t)(pixel & 0x1f) * 0xff / 0x1f);
         uint8_t g = (uint8_t)((uint32_t)((pixel >> 5) & 0x1f) * 0xff / 0x1f);
         uint8_t r = (uint8_t)((uint32_t)((pixel >> 10) & 0x1f) * 0xff / 0x1f);
         uint8_t a = (uint8_t)((uint32_t)(pixel >> 15) * 0xff / 0x1);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = a; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_b4g4r4a4_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint16_t *src_pixel = (const uint16_t *)(src_row + x0*2);
      for (x = 0; x < w; ++x) {
         uint16_t pixel = *src_pixel++;
         uint8_t b = (uint8_t)((uint32_t)(pixel & 0xf) * 0xff / 0xf);
         uint8_t g = (uint8_t)((uint32_t)((pixel >> 4) & 0xf) * 0xff / 0xf);
         uint8_t r = (uint8_t)((uint32_t)((pixel >> 8) & 0xf) * 0xff / 0xf);
         uint8_t a = (uint8_t)((uint32_t)(pixel >> 12) * 0xff / 0xf);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = a; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_b5g6r5_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint16_t *src_pixel = (const uint16_t *)(src_row + x0*2);
      for (x = 0; x < w; ++x) {
         uint16_t pixel = *src_pixel++;
         uint8_t b = (uint8_t)((uint32_t)(pixel & 0x1f) * 0xff / 0x1f);
         uint8_t g = (uint8_t)((uint32_t)((pixel >> 5) & 0x3f) * 0xff / 0x3f);
         uint8_t r = (uint8_t)((uint32_t)(pixel >> 11) * 0xff / 0x1f);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r10g10b10a2_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint32_t *src_pixel = (const uint32_t *)(src_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint32_t pixel = *src_pixel++;
         uint8_t r = (uint8_t)((pixel & 0x3ff) >> 2);
         uint8_t g = (uint8_t)(((pixel >> 10) & 0x3ff) >> 2);
         uint8_t b = (uint8_t)(((pixel >> 20) & 0x3ff) >> 2);
         uint8_t a = (uint8_t)((uint32_t)(pixel >> 30) * 0xff / 0x3);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = a; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_l8_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint8_t *src_pixel = (const uint8_t *)(src_row + x0*1);
      for (x = 0; x < w; ++x) {
         uint8_t rgb = (*src_pixel++);
         TILE_PIXEL(dst, x, y, 0) = rgb; /* r */
         TILE_PIXEL(dst, x, y, 1) = rgb; /* g */
         TILE_PIXEL(dst, x, y, 2) = rgb; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_a8_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint8_t *src_pixel = (const uint8_t *)(src_row + x0*1);
      for (x = 0; x < w; ++x) {
         uint8_t a = (*src_pixel++);
         TILE_PIXEL(dst, x, y, 0) = 0; /* r */
         TILE_PIXEL(dst, x, y, 1) = 0; /* g */
         TILE_PIXEL(dst, x, y, 2) = 0; /* b */
         TILE_PIXEL(dst, x, y, 3) = a; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_i8_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint8_t *src_pixel = (const uint8_t *)(src_row + x0*1);
      for (x = 0; x < w; ++x) {
         uint8_t rgba = (*src_pixel++);
         TILE_PIXEL(dst, x, y, 0) = rgba; /* r */
         TILE_PIXEL(dst, x, y, 1) = rgba; /* g */
         TILE_PIXEL(dst, x, y, 2) = rgba; /* b */
         TILE_PIXEL(dst, x, y, 3) = rgba; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_l8a8_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint8_t *src_pixel = (const uint8_t *)(src_row + x0*2);
      for (x = 0; x < w; ++x) {
         uint8_t rgb = (*src_pixel++);
         uint8_t a = (*src_pixel++);
         TILE_PIXEL(dst, x, y, 0) = rgb; /* r */
         TILE_PIXEL(dst, x, y, 1) = rgb; /* g */
         TILE_PIXEL(dst, x, y, 2) = rgb; /* b */
         TILE_PIXEL(dst, x, y, 3) = a; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_l16_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint16_t *src_pixel = (const uint16_t *)(src_row + x0*2);
      for (x = 0; x < w; ++x) {
         uint8_t rgb = (uint8_t)((*src_pixel++) >> 8);
         TILE_PIXEL(dst, x, y, 0) = rgb; /* r */
         TILE_PIXEL(dst, x, y, 1) = rgb; /* g */
         TILE_PIXEL(dst, x, y, 2) = rgb; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_z16_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint16_t *src_pixel = (const uint16_t *)(src_row + x0*2);
      for (x = 0; x < w; ++x) {
         uint8_t z = (uint8_t)((*src_pixel++) >> 8);
         TILE_PIXEL(dst, x, y, 0) = z; /* r */
         TILE_PIXEL(dst, x, y, 1) = z; /* g */
         TILE_PIXEL(dst, x, y, 2) = z; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_z32_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint32_t *src_pixel = (const uint32_t *)(src_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint8_t z = (uint8_t)((*src_pixel++) >> 24);
         TILE_PIXEL(dst, x, y, 0) = z; /* r */
         TILE_PIXEL(dst, x, y, 1) = z; /* g */
         TILE_PIXEL(dst, x, y, 2) = z; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_z32_float_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const float *src_pixel = (const float *)(src_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint8_t z = (uint8_t)((*src_pixel++) * 0xff);
         TILE_PIXEL(dst, x, y, 0) = z; /* r */
         TILE_PIXEL(dst, x, y, 1) = z; /* g */
         TILE_PIXEL(dst, x, y, 2) = z; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_z24s8_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint32_t *src_pixel = (const uint32_t *)(src_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint32_t pixel = *src_pixel++;
         uint8_t z = (uint8_t)((pixel & 0xffffff) >> 16);
         TILE_PIXEL(dst, x, y, 0) = z; /* r */
         TILE_PIXEL(dst, x, y, 1) = z; /* g */
         TILE_PIXEL(dst, x, y, 2) = z; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_s8z24_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint32_t *src_pixel = (const uint32_t *)(src_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint32_t pixel = *src_pixel++;
         uint8_t z = (uint8_t)((pixel >> 8) >> 16);
         TILE_PIXEL(dst, x, y, 0) = z; /* r */
         TILE_PIXEL(dst, x, y, 1) = z; /* g */
         TILE_PIXEL(dst, x, y, 2) = z; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_z24x8_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint32_t *src_pixel = (const uint32_t *)(src_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint32_t pixel = *src_pixel++;
         uint8_t z = (uint8_t)((pixel & 0xffffff) >> 16);
         TILE_PIXEL(dst, x, y, 0) = z; /* r */
         TILE_PIXEL(dst, x, y, 1) = z; /* g */
         TILE_PIXEL(dst, x, y, 2) = z; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_x8z24_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint32_t *src_pixel = (const uint32_t *)(src_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint32_t pixel = *src_pixel++;
         uint8_t z = (uint8_t)((pixel >> 8) >> 16);
         TILE_PIXEL(dst, x, y, 0) = z; /* r */
         TILE_PIXEL(dst, x, y, 1) = z; /* g */
         TILE_PIXEL(dst, x, y, 2) = z; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r64_float_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const double *src_pixel = (const double *)(src_row + x0*8);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((*src_pixel++) * 0xff);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = 0; /* g */
         TILE_PIXEL(dst, x, y, 2) = 0; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r64g64_float_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const double *src_pixel = (const double *)(src_row + x0*16);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((*src_pixel++) * 0xff);
         uint8_t g = (uint8_t)((*src_pixel++) * 0xff);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = 0; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r64g64b64_float_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const double *src_pixel = (const double *)(src_row + x0*24);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((*src_pixel++) * 0xff);
         uint8_t g = (uint8_t)((*src_pixel++) * 0xff);
         uint8_t b = (uint8_t)((*src_pixel++) * 0xff);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r64g64b64a64_float_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const double *src_pixel = (const double *)(src_row + x0*32);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((*src_pixel++) * 0xff);
         uint8_t g = (uint8_t)((*src_pixel++) * 0xff);
         uint8_t b = (uint8_t)((*src_pixel++) * 0xff);
         uint8_t a = (uint8_t)((*src_pixel++) * 0xff);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = a; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r32_float_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const float *src_pixel = (const float *)(src_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((*src_pixel++) * 0xff);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = 0; /* g */
         TILE_PIXEL(dst, x, y, 2) = 0; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r32g32_float_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const float *src_pixel = (const float *)(src_row + x0*8);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((*src_pixel++) * 0xff);
         uint8_t g = (uint8_t)((*src_pixel++) * 0xff);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = 0; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r32g32b32_float_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const float *src_pixel = (const float *)(src_row + x0*12);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((*src_pixel++) * 0xff);
         uint8_t g = (uint8_t)((*src_pixel++) * 0xff);
         uint8_t b = (uint8_t)((*src_pixel++) * 0xff);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r32g32b32a32_float_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const float *src_pixel = (const float *)(src_row + x0*16);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((*src_pixel++) * 0xff);
         uint8_t g = (uint8_t)((*src_pixel++) * 0xff);
         uint8_t b = (uint8_t)((*src_pixel++) * 0xff);
         uint8_t a = (uint8_t)((*src_pixel++) * 0xff);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = a; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r32_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint32_t *src_pixel = (const uint32_t *)(src_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((*src_pixel++) >> 24);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = 0; /* g */
         TILE_PIXEL(dst, x, y, 2) = 0; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r32g32_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint32_t *src_pixel = (const uint32_t *)(src_row + x0*8);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((*src_pixel++) >> 24);
         uint8_t g = (uint8_t)((*src_pixel++) >> 24);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = 0; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r32g32b32_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint32_t *src_pixel = (const uint32_t *)(src_row + x0*12);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((*src_pixel++) >> 24);
         uint8_t g = (uint8_t)((*src_pixel++) >> 24);
         uint8_t b = (uint8_t)((*src_pixel++) >> 24);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r32g32b32a32_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint32_t *src_pixel = (const uint32_t *)(src_row + x0*16);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((*src_pixel++) >> 24);
         uint8_t g = (uint8_t)((*src_pixel++) >> 24);
         uint8_t b = (uint8_t)((*src_pixel++) >> 24);
         uint8_t a = (uint8_t)((*src_pixel++) >> 24);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = a; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r32_uscaled_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint32_t *src_pixel = (const uint32_t *)(src_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((uint64_t)(*src_pixel++) * 0xff / 0x1);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = 0; /* g */
         TILE_PIXEL(dst, x, y, 2) = 0; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r32g32_uscaled_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint32_t *src_pixel = (const uint32_t *)(src_row + x0*8);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((uint64_t)(*src_pixel++) * 0xff / 0x1);
         uint8_t g = (uint8_t)((uint64_t)(*src_pixel++) * 0xff / 0x1);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = 0; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r32g32b32_uscaled_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint32_t *src_pixel = (const uint32_t *)(src_row + x0*12);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((uint64_t)(*src_pixel++) * 0xff / 0x1);
         uint8_t g = (uint8_t)((uint64_t)(*src_pixel++) * 0xff / 0x1);
         uint8_t b = (uint8_t)((uint64_t)(*src_pixel++) * 0xff / 0x1);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r32g32b32a32_uscaled_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint32_t *src_pixel = (const uint32_t *)(src_row + x0*16);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((uint64_t)(*src_pixel++) * 0xff / 0x1);
         uint8_t g = (uint8_t)((uint64_t)(*src_pixel++) * 0xff / 0x1);
         uint8_t b = (uint8_t)((uint64_t)(*src_pixel++) * 0xff / 0x1);
         uint8_t a = (uint8_t)((uint64_t)(*src_pixel++) * 0xff / 0x1);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = a; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r16_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint16_t *src_pixel = (const uint16_t *)(src_row + x0*2);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((*src_pixel++) >> 8);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = 0; /* g */
         TILE_PIXEL(dst, x, y, 2) = 0; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r16g16_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint16_t *src_pixel = (const uint16_t *)(src_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((*src_pixel++) >> 8);
         uint8_t g = (uint8_t)((*src_pixel++) >> 8);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = 0; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r16g16b16_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint16_t *src_pixel = (const uint16_t *)(src_row + x0*6);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((*src_pixel++) >> 8);
         uint8_t g = (uint8_t)((*src_pixel++) >> 8);
         uint8_t b = (uint8_t)((*src_pixel++) >> 8);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r16g16b16a16_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint16_t *src_pixel = (const uint16_t *)(src_row + x0*8);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((*src_pixel++) >> 8);
         uint8_t g = (uint8_t)((*src_pixel++) >> 8);
         uint8_t b = (uint8_t)((*src_pixel++) >> 8);
         uint8_t a = (uint8_t)((*src_pixel++) >> 8);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = a; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r16_uscaled_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint16_t *src_pixel = (const uint16_t *)(src_row + x0*2);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((uint32_t)(*src_pixel++) * 0xff / 0x1);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = 0; /* g */
         TILE_PIXEL(dst, x, y, 2) = 0; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r16g16_uscaled_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint16_t *src_pixel = (const uint16_t *)(src_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((uint32_t)(*src_pixel++) * 0xff / 0x1);
         uint8_t g = (uint8_t)((uint32_t)(*src_pixel++) * 0xff / 0x1);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = 0; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r16g16b16_uscaled_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint16_t *src_pixel = (const uint16_t *)(src_row + x0*6);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((uint32_t)(*src_pixel++) * 0xff / 0x1);
         uint8_t g = (uint8_t)((uint32_t)(*src_pixel++) * 0xff / 0x1);
         uint8_t b = (uint8_t)((uint32_t)(*src_pixel++) * 0xff / 0x1);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r16g16b16a16_uscaled_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint16_t *src_pixel = (const uint16_t *)(src_row + x0*8);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((uint32_t)(*src_pixel++) * 0xff / 0x1);
         uint8_t g = (uint8_t)((uint32_t)(*src_pixel++) * 0xff / 0x1);
         uint8_t b = (uint8_t)((uint32_t)(*src_pixel++) * 0xff / 0x1);
         uint8_t a = (uint8_t)((uint32_t)(*src_pixel++) * 0xff / 0x1);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = a; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r8_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint8_t *src_pixel = (const uint8_t *)(src_row + x0*1);
      for (x = 0; x < w; ++x) {
         uint8_t r = (*src_pixel++);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = 0; /* g */
         TILE_PIXEL(dst, x, y, 2) = 0; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r8g8_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint8_t *src_pixel = (const uint8_t *)(src_row + x0*2);
      for (x = 0; x < w; ++x) {
         uint8_t r = (*src_pixel++);
         uint8_t g = (*src_pixel++);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = 0; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r8g8b8_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint8_t *src_pixel = (const uint8_t *)(src_row + x0*3);
      for (x = 0; x < w; ++x) {
         uint8_t r = (*src_pixel++);
         uint8_t g = (*src_pixel++);
         uint8_t b = (*src_pixel++);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r8g8b8a8_unorm_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint8_t *src_pixel = (const uint8_t *)(src_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint8_t r = (*src_pixel++);
         uint8_t g = (*src_pixel++);
         uint8_t b = (*src_pixel++);
         uint8_t a = (*src_pixel++);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = a; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r8_uscaled_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint8_t *src_pixel = (const uint8_t *)(src_row + x0*1);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((uint32_t)(*src_pixel++) * 0xff / 0x1);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = 0; /* g */
         TILE_PIXEL(dst, x, y, 2) = 0; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r8g8_uscaled_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint8_t *src_pixel = (const uint8_t *)(src_row + x0*2);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((uint32_t)(*src_pixel++) * 0xff / 0x1);
         uint8_t g = (uint8_t)((uint32_t)(*src_pixel++) * 0xff / 0x1);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = 0; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r8g8b8_uscaled_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint8_t *src_pixel = (const uint8_t *)(src_row + x0*3);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((uint32_t)(*src_pixel++) * 0xff / 0x1);
         uint8_t g = (uint8_t)((uint32_t)(*src_pixel++) * 0xff / 0x1);
         uint8_t b = (uint8_t)((uint32_t)(*src_pixel++) * 0xff / 0x1);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = 255; /* a */
      }
      src_row += src_stride;
   }
}

static void
lp_tile_r8g8b8a8_uscaled_read_4ub(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   const uint8_t *src_row = src + y0*src_stride;
   for (y = 0; y < h; ++y) {
      const uint8_t *src_pixel = (const uint8_t *)(src_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint8_t r = (uint8_t)((uint32_t)(*src_pixel++) * 0xff / 0x1);
         uint8_t g = (uint8_t)((uint32_t)(*src_pixel++) * 0xff / 0x1);
         uint8_t b = (uint8_t)((uint32_t)(*src_pixel++) * 0xff / 0x1);
         uint8_t a = (uint8_t)((uint32_t)(*src_pixel++) * 0xff / 0x1);
         TILE_PIXEL(dst, x, y, 0) = r; /* r */
         TILE_PIXEL(dst, x, y, 1) = g; /* g */
         TILE_PIXEL(dst, x, y, 2) = b; /* b */
         TILE_PIXEL(dst, x, y, 3) = a; /* a */
      }
      src_row += src_stride;
   }
}

void
lp_tile_read_4ub(enum pipe_format format, uint8_t *dst, const void *src, unsigned src_stride, unsigned x, unsigned y, unsigned w, unsigned h)
{
   void (*func)(uint8_t *dst, const uint8_t *src, unsigned src_stride, unsigned x0, unsigned y0, unsigned w, unsigned h);
   switch(format) {
   case PIPE_FORMAT_B8G8R8A8_UNORM:
      func = &lp_tile_b8g8r8a8_unorm_read_4ub;
      break;
   case PIPE_FORMAT_B8G8R8X8_UNORM:
      func = &lp_tile_b8g8r8x8_unorm_read_4ub;
      break;
   case PIPE_FORMAT_A8R8G8B8_UNORM:
      func = &lp_tile_a8r8g8b8_unorm_read_4ub;
      break;
   case PIPE_FORMAT_X8R8G8B8_UNORM:
      func = &lp_tile_x8r8g8b8_unorm_read_4ub;
      break;
   case PIPE_FORMAT_A8B8G8R8_UNORM:
      func = &lp_tile_a8b8g8r8_unorm_read_4ub;
      break;
   case PIPE_FORMAT_X8B8G8R8_UNORM:
      func = &lp_tile_x8b8g8r8_unorm_read_4ub;
      break;
   case PIPE_FORMAT_B5G5R5A1_UNORM:
      func = &lp_tile_b5g5r5a1_unorm_read_4ub;
      break;
   case PIPE_FORMAT_B4G4R4A4_UNORM:
      func = &lp_tile_b4g4r4a4_unorm_read_4ub;
      break;
   case PIPE_FORMAT_B5G6R5_UNORM:
      func = &lp_tile_b5g6r5_unorm_read_4ub;
      break;
   case PIPE_FORMAT_R10G10B10A2_UNORM:
      func = &lp_tile_r10g10b10a2_unorm_read_4ub;
      break;
   case PIPE_FORMAT_L8_UNORM:
      func = &lp_tile_l8_unorm_read_4ub;
      break;
   case PIPE_FORMAT_A8_UNORM:
      func = &lp_tile_a8_unorm_read_4ub;
      break;
   case PIPE_FORMAT_I8_UNORM:
      func = &lp_tile_i8_unorm_read_4ub;
      break;
   case PIPE_FORMAT_L8A8_UNORM:
      func = &lp_tile_l8a8_unorm_read_4ub;
      break;
   case PIPE_FORMAT_L16_UNORM:
      func = &lp_tile_l16_unorm_read_4ub;
      break;
   case PIPE_FORMAT_Z16_UNORM:
      func = &lp_tile_z16_unorm_read_4ub;
      break;
   case PIPE_FORMAT_Z32_UNORM:
      func = &lp_tile_z32_unorm_read_4ub;
      break;
   case PIPE_FORMAT_Z32_FLOAT:
      func = &lp_tile_z32_float_read_4ub;
      break;
   case PIPE_FORMAT_Z24S8_UNORM:
      func = &lp_tile_z24s8_unorm_read_4ub;
      break;
   case PIPE_FORMAT_S8Z24_UNORM:
      func = &lp_tile_s8z24_unorm_read_4ub;
      break;
   case PIPE_FORMAT_Z24X8_UNORM:
      func = &lp_tile_z24x8_unorm_read_4ub;
      break;
   case PIPE_FORMAT_X8Z24_UNORM:
      func = &lp_tile_x8z24_unorm_read_4ub;
      break;
   case PIPE_FORMAT_R64_FLOAT:
      func = &lp_tile_r64_float_read_4ub;
      break;
   case PIPE_FORMAT_R64G64_FLOAT:
      func = &lp_tile_r64g64_float_read_4ub;
      break;
   case PIPE_FORMAT_R64G64B64_FLOAT:
      func = &lp_tile_r64g64b64_float_read_4ub;
      break;
   case PIPE_FORMAT_R64G64B64A64_FLOAT:
      func = &lp_tile_r64g64b64a64_float_read_4ub;
      break;
   case PIPE_FORMAT_R32_FLOAT:
      func = &lp_tile_r32_float_read_4ub;
      break;
   case PIPE_FORMAT_R32G32_FLOAT:
      func = &lp_tile_r32g32_float_read_4ub;
      break;
   case PIPE_FORMAT_R32G32B32_FLOAT:
      func = &lp_tile_r32g32b32_float_read_4ub;
      break;
   case PIPE_FORMAT_R32G32B32A32_FLOAT:
      func = &lp_tile_r32g32b32a32_float_read_4ub;
      break;
   case PIPE_FORMAT_R32_UNORM:
      func = &lp_tile_r32_unorm_read_4ub;
      break;
   case PIPE_FORMAT_R32G32_UNORM:
      func = &lp_tile_r32g32_unorm_read_4ub;
      break;
   case PIPE_FORMAT_R32G32B32_UNORM:
      func = &lp_tile_r32g32b32_unorm_read_4ub;
      break;
   case PIPE_FORMAT_R32G32B32A32_UNORM:
      func = &lp_tile_r32g32b32a32_unorm_read_4ub;
      break;
   case PIPE_FORMAT_R32_USCALED:
      func = &lp_tile_r32_uscaled_read_4ub;
      break;
   case PIPE_FORMAT_R32G32_USCALED:
      func = &lp_tile_r32g32_uscaled_read_4ub;
      break;
   case PIPE_FORMAT_R32G32B32_USCALED:
      func = &lp_tile_r32g32b32_uscaled_read_4ub;
      break;
   case PIPE_FORMAT_R32G32B32A32_USCALED:
      func = &lp_tile_r32g32b32a32_uscaled_read_4ub;
      break;
   case PIPE_FORMAT_R16_UNORM:
      func = &lp_tile_r16_unorm_read_4ub;
      break;
   case PIPE_FORMAT_R16G16_UNORM:
      func = &lp_tile_r16g16_unorm_read_4ub;
      break;
   case PIPE_FORMAT_R16G16B16_UNORM:
      func = &lp_tile_r16g16b16_unorm_read_4ub;
      break;
   case PIPE_FORMAT_R16G16B16A16_UNORM:
      func = &lp_tile_r16g16b16a16_unorm_read_4ub;
      break;
   case PIPE_FORMAT_R16_USCALED:
      func = &lp_tile_r16_uscaled_read_4ub;
      break;
   case PIPE_FORMAT_R16G16_USCALED:
      func = &lp_tile_r16g16_uscaled_read_4ub;
      break;
   case PIPE_FORMAT_R16G16B16_USCALED:
      func = &lp_tile_r16g16b16_uscaled_read_4ub;
      break;
   case PIPE_FORMAT_R16G16B16A16_USCALED:
      func = &lp_tile_r16g16b16a16_uscaled_read_4ub;
      break;
   case PIPE_FORMAT_R8_UNORM:
      func = &lp_tile_r8_unorm_read_4ub;
      break;
   case PIPE_FORMAT_R8G8_UNORM:
      func = &lp_tile_r8g8_unorm_read_4ub;
      break;
   case PIPE_FORMAT_R8G8B8_UNORM:
      func = &lp_tile_r8g8b8_unorm_read_4ub;
      break;
   case PIPE_FORMAT_R8G8B8A8_UNORM:
      func = &lp_tile_r8g8b8a8_unorm_read_4ub;
      break;
   case PIPE_FORMAT_R8_USCALED:
      func = &lp_tile_r8_uscaled_read_4ub;
      break;
   case PIPE_FORMAT_R8G8_USCALED:
      func = &lp_tile_r8g8_uscaled_read_4ub;
      break;
   case PIPE_FORMAT_R8G8B8_USCALED:
      func = &lp_tile_r8g8b8_uscaled_read_4ub;
      break;
   case PIPE_FORMAT_R8G8B8A8_USCALED:
      func = &lp_tile_r8g8b8a8_uscaled_read_4ub;
      break;
   default:
      debug_printf("unsupported format\n");
      return;
   }
   func(dst, (const uint8_t *)src, src_stride, x, y, w, h);
}

static void
lp_tile_b8g8r8a8_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 4;
   uint32_t *dstpix = (uint32_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = ((b[i+0]) << 0) | ((g[i+0]) << 8) | ((r[i+0]) << 16) | ((a[i+0]) << 24);
            const uint32_t pixel1 = ((b[i+1]) << 0) | ((g[i+1]) << 8) | ((r[i+1]) << 16) | ((a[i+1]) << 24);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_b8g8r8x8_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 4;
   uint32_t *dstpix = (uint32_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = ((b[i+0]) << 0) | ((g[i+0]) << 8) | ((r[i+0]) << 16);
            const uint32_t pixel1 = ((b[i+1]) << 0) | ((g[i+1]) << 8) | ((r[i+1]) << 16);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_a8r8g8b8_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 4;
   uint32_t *dstpix = (uint32_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = ((a[i+0]) << 0) | ((r[i+0]) << 8) | ((g[i+0]) << 16) | ((b[i+0]) << 24);
            const uint32_t pixel1 = ((a[i+1]) << 0) | ((r[i+1]) << 8) | ((g[i+1]) << 16) | ((b[i+1]) << 24);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_x8r8g8b8_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 4;
   uint32_t *dstpix = (uint32_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = ((r[i+0]) << 8) | ((g[i+0]) << 16) | ((b[i+0]) << 24);
            const uint32_t pixel1 = ((r[i+1]) << 8) | ((g[i+1]) << 16) | ((b[i+1]) << 24);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_a8b8g8r8_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 4;
   uint32_t *dstpix = (uint32_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = ((a[i+0]) << 0) | ((b[i+0]) << 8) | ((g[i+0]) << 16) | ((r[i+0]) << 24);
            const uint32_t pixel1 = ((a[i+1]) << 0) | ((b[i+1]) << 8) | ((g[i+1]) << 16) | ((r[i+1]) << 24);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_x8b8g8r8_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 4;
   uint32_t *dstpix = (uint32_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = ((b[i+0]) << 8) | ((g[i+0]) << 16) | ((r[i+0]) << 24);
            const uint32_t pixel1 = ((b[i+1]) << 8) | ((g[i+1]) << 16) | ((r[i+1]) << 24);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_b5g5r5a1_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 2;
   uint16_t *dstpix = (uint16_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = (((uint16_t)(b[i+0] >> 3)) << 0) | (((uint16_t)(g[i+0] >> 3)) << 5) | (((uint16_t)(r[i+0] >> 3)) << 10) | (((uint16_t)(a[i+0] >> 7)) << 15);
            const uint32_t pixel1 = (((uint16_t)(b[i+1] >> 3)) << 0) | (((uint16_t)(g[i+1] >> 3)) << 5) | (((uint16_t)(r[i+1] >> 3)) << 10) | (((uint16_t)(a[i+1] >> 7)) << 15);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_b4g4r4a4_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 2;
   uint16_t *dstpix = (uint16_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = (((uint16_t)(b[i+0] >> 4)) << 0) | (((uint16_t)(g[i+0] >> 4)) << 4) | (((uint16_t)(r[i+0] >> 4)) << 8) | (((uint16_t)(a[i+0] >> 4)) << 12);
            const uint32_t pixel1 = (((uint16_t)(b[i+1] >> 4)) << 0) | (((uint16_t)(g[i+1] >> 4)) << 4) | (((uint16_t)(r[i+1] >> 4)) << 8) | (((uint16_t)(a[i+1] >> 4)) << 12);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_b5g6r5_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 2;
   uint16_t *dstpix = (uint16_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = (((uint16_t)(b[i+0] >> 3)) << 0) | (((uint16_t)(g[i+0] >> 2)) << 5) | (((uint16_t)(r[i+0] >> 3)) << 11);
            const uint32_t pixel1 = (((uint16_t)(b[i+1] >> 3)) << 0) | (((uint16_t)(g[i+1] >> 2)) << 5) | (((uint16_t)(r[i+1] >> 3)) << 11);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_r10g10b10a2_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 4;
   uint32_t *dstpix = (uint32_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = (((uint32_t)((uint32_t)r[i+0] * 0x3ff / 0xff)) << 0) | (((uint32_t)((uint32_t)g[i+0] * 0x3ff / 0xff)) << 10) | (((uint32_t)((uint32_t)b[i+0] * 0x3ff / 0xff)) << 20) | (((uint32_t)(a[i+0] >> 6)) << 30);
            const uint32_t pixel1 = (((uint32_t)((uint32_t)r[i+1] * 0x3ff / 0xff)) << 0) | (((uint32_t)((uint32_t)g[i+1] * 0x3ff / 0xff)) << 10) | (((uint32_t)((uint32_t)b[i+1] * 0x3ff / 0xff)) << 20) | (((uint32_t)(a[i+1] >> 6)) << 30);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_l8_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 1;
   uint8_t *dstpix = (uint8_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = ((b[i+0]) << 0);
            const uint32_t pixel1 = ((b[i+1]) << 0);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_a8_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 1;
   uint8_t *dstpix = (uint8_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = ((a[i+0]) << 0);
            const uint32_t pixel1 = ((a[i+1]) << 0);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_i8_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 1;
   uint8_t *dstpix = (uint8_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = ((a[i+0]) << 0);
            const uint32_t pixel1 = ((a[i+1]) << 0);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_l8a8_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 2;
   uint16_t *dstpix = (uint16_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = ((b[i+0]) << 0) | ((a[i+0]) << 8);
            const uint32_t pixel1 = ((b[i+1]) << 0) | ((a[i+1]) << 8);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_l16_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 2;
   uint16_t *dstpix = (uint16_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = (((uint16_t)((uint32_t)b[i+0] * 0xffff / 0xff)) << 0);
            const uint32_t pixel1 = (((uint16_t)((uint32_t)b[i+1] * 0xffff / 0xff)) << 0);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_z16_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      uint16_t *dst_pixel = (uint16_t *)(dst_row + x0*2);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (uint16_t)((uint32_t)TILE_PIXEL(src, x, y, 0) * 0xffff / 0xff);
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_z32_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      uint32_t *dst_pixel = (uint32_t *)(dst_row + x0*4);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (uint32_t)((uint64_t)TILE_PIXEL(src, x, y, 0) * 0xffffffff / 0xff);
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_z32_float_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      float *dst_pixel = (float *)(dst_row + x0*4);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (float)(TILE_PIXEL(src, x, y, 0) * (1.0f/0xff));
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_z24s8_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      uint32_t *dst_pixel = (uint32_t *)(dst_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint32_t pixel = 0;
         pixel |= (uint32_t)((uint32_t)TILE_PIXEL(src, x, y, 0) * 0xffffff / 0xff);
         pixel |= (TILE_PIXEL(src, x, y, 1) << 24);
         *dst_pixel++ = pixel;
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_s8z24_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      uint32_t *dst_pixel = (uint32_t *)(dst_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint32_t pixel = 0;
         pixel |= TILE_PIXEL(src, x, y, 1);
         pixel |= ((uint32_t)((uint32_t)TILE_PIXEL(src, x, y, 0) * 0xffffff / 0xff) << 8);
         *dst_pixel++ = pixel;
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_z24x8_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      uint32_t *dst_pixel = (uint32_t *)(dst_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint32_t pixel = 0;
         pixel |= (uint32_t)((uint32_t)TILE_PIXEL(src, x, y, 0) * 0xffffff / 0xff);
         *dst_pixel++ = pixel;
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_x8z24_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      uint32_t *dst_pixel = (uint32_t *)(dst_row + x0*4);
      for (x = 0; x < w; ++x) {
         uint32_t pixel = 0;
         pixel |= ((uint32_t)((uint32_t)TILE_PIXEL(src, x, y, 0) * 0xffffff / 0xff) << 8);
         *dst_pixel++ = pixel;
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_r64_float_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      double *dst_pixel = (double *)(dst_row + x0*8);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (double)(TILE_PIXEL(src, x, y, 0) * (1.0f/0xff));
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_r64g64_float_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      double *dst_pixel = (double *)(dst_row + x0*16);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (double)(TILE_PIXEL(src, x, y, 0) * (1.0f/0xff));
         *dst_pixel++ = (double)(TILE_PIXEL(src, x, y, 1) * (1.0f/0xff));
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_r64g64b64_float_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      double *dst_pixel = (double *)(dst_row + x0*24);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (double)(TILE_PIXEL(src, x, y, 0) * (1.0f/0xff));
         *dst_pixel++ = (double)(TILE_PIXEL(src, x, y, 1) * (1.0f/0xff));
         *dst_pixel++ = (double)(TILE_PIXEL(src, x, y, 2) * (1.0f/0xff));
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_r64g64b64a64_float_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      double *dst_pixel = (double *)(dst_row + x0*32);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (double)(TILE_PIXEL(src, x, y, 0) * (1.0f/0xff));
         *dst_pixel++ = (double)(TILE_PIXEL(src, x, y, 1) * (1.0f/0xff));
         *dst_pixel++ = (double)(TILE_PIXEL(src, x, y, 2) * (1.0f/0xff));
         *dst_pixel++ = (double)(TILE_PIXEL(src, x, y, 3) * (1.0f/0xff));
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_r32_float_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      float *dst_pixel = (float *)(dst_row + x0*4);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (float)(TILE_PIXEL(src, x, y, 0) * (1.0f/0xff));
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_r32g32_float_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      float *dst_pixel = (float *)(dst_row + x0*8);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (float)(TILE_PIXEL(src, x, y, 0) * (1.0f/0xff));
         *dst_pixel++ = (float)(TILE_PIXEL(src, x, y, 1) * (1.0f/0xff));
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_r32g32b32_float_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      float *dst_pixel = (float *)(dst_row + x0*12);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (float)(TILE_PIXEL(src, x, y, 0) * (1.0f/0xff));
         *dst_pixel++ = (float)(TILE_PIXEL(src, x, y, 1) * (1.0f/0xff));
         *dst_pixel++ = (float)(TILE_PIXEL(src, x, y, 2) * (1.0f/0xff));
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_r32g32b32a32_float_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      float *dst_pixel = (float *)(dst_row + x0*16);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (float)(TILE_PIXEL(src, x, y, 0) * (1.0f/0xff));
         *dst_pixel++ = (float)(TILE_PIXEL(src, x, y, 1) * (1.0f/0xff));
         *dst_pixel++ = (float)(TILE_PIXEL(src, x, y, 2) * (1.0f/0xff));
         *dst_pixel++ = (float)(TILE_PIXEL(src, x, y, 3) * (1.0f/0xff));
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_r32_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 4;
   uint32_t *dstpix = (uint32_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = (((uint32_t)((uint64_t)r[i+0] * 0xffffffff / 0xff)) << 0);
            const uint32_t pixel1 = (((uint32_t)((uint64_t)r[i+1] * 0xffffffff / 0xff)) << 0);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_r32g32_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      uint32_t *dst_pixel = (uint32_t *)(dst_row + x0*8);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (uint32_t)((uint64_t)TILE_PIXEL(src, x, y, 0) * 0xffffffff / 0xff);
         *dst_pixel++ = (uint32_t)((uint64_t)TILE_PIXEL(src, x, y, 1) * 0xffffffff / 0xff);
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_r32g32b32_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      uint32_t *dst_pixel = (uint32_t *)(dst_row + x0*12);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (uint32_t)((uint64_t)TILE_PIXEL(src, x, y, 0) * 0xffffffff / 0xff);
         *dst_pixel++ = (uint32_t)((uint64_t)TILE_PIXEL(src, x, y, 1) * 0xffffffff / 0xff);
         *dst_pixel++ = (uint32_t)((uint64_t)TILE_PIXEL(src, x, y, 2) * 0xffffffff / 0xff);
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_r32g32b32a32_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      uint32_t *dst_pixel = (uint32_t *)(dst_row + x0*16);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (uint32_t)((uint64_t)TILE_PIXEL(src, x, y, 0) * 0xffffffff / 0xff);
         *dst_pixel++ = (uint32_t)((uint64_t)TILE_PIXEL(src, x, y, 1) * 0xffffffff / 0xff);
         *dst_pixel++ = (uint32_t)((uint64_t)TILE_PIXEL(src, x, y, 2) * 0xffffffff / 0xff);
         *dst_pixel++ = (uint32_t)((uint64_t)TILE_PIXEL(src, x, y, 3) * 0xffffffff / 0xff);
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_r32_uscaled_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 4;
   uint32_t *dstpix = (uint32_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = (((uint32_t)(r[i+0] >> 8)) << 0);
            const uint32_t pixel1 = (((uint32_t)(r[i+1] >> 8)) << 0);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_r32g32_uscaled_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      uint32_t *dst_pixel = (uint32_t *)(dst_row + x0*8);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (uint32_t)(TILE_PIXEL(src, x, y, 0) >> 8);
         *dst_pixel++ = (uint32_t)(TILE_PIXEL(src, x, y, 1) >> 8);
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_r32g32b32_uscaled_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      uint32_t *dst_pixel = (uint32_t *)(dst_row + x0*12);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (uint32_t)(TILE_PIXEL(src, x, y, 0) >> 8);
         *dst_pixel++ = (uint32_t)(TILE_PIXEL(src, x, y, 1) >> 8);
         *dst_pixel++ = (uint32_t)(TILE_PIXEL(src, x, y, 2) >> 8);
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_r32g32b32a32_uscaled_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      uint32_t *dst_pixel = (uint32_t *)(dst_row + x0*16);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (uint32_t)(TILE_PIXEL(src, x, y, 0) >> 8);
         *dst_pixel++ = (uint32_t)(TILE_PIXEL(src, x, y, 1) >> 8);
         *dst_pixel++ = (uint32_t)(TILE_PIXEL(src, x, y, 2) >> 8);
         *dst_pixel++ = (uint32_t)(TILE_PIXEL(src, x, y, 3) >> 8);
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_r16_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 2;
   uint16_t *dstpix = (uint16_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = (((uint16_t)((uint32_t)r[i+0] * 0xffff / 0xff)) << 0);
            const uint32_t pixel1 = (((uint16_t)((uint32_t)r[i+1] * 0xffff / 0xff)) << 0);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_r16g16_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 4;
   uint32_t *dstpix = (uint32_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = (((uint16_t)((uint32_t)r[i+0] * 0xffff / 0xff)) << 0) | (((uint16_t)((uint32_t)g[i+0] * 0xffff / 0xff)) << 16);
            const uint32_t pixel1 = (((uint16_t)((uint32_t)r[i+1] * 0xffff / 0xff)) << 0) | (((uint16_t)((uint32_t)g[i+1] * 0xffff / 0xff)) << 16);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_r16g16b16_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      uint16_t *dst_pixel = (uint16_t *)(dst_row + x0*6);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (uint16_t)((uint32_t)TILE_PIXEL(src, x, y, 0) * 0xffff / 0xff);
         *dst_pixel++ = (uint16_t)((uint32_t)TILE_PIXEL(src, x, y, 1) * 0xffff / 0xff);
         *dst_pixel++ = (uint16_t)((uint32_t)TILE_PIXEL(src, x, y, 2) * 0xffff / 0xff);
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_r16g16b16a16_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      uint16_t *dst_pixel = (uint16_t *)(dst_row + x0*8);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (uint16_t)((uint32_t)TILE_PIXEL(src, x, y, 0) * 0xffff / 0xff);
         *dst_pixel++ = (uint16_t)((uint32_t)TILE_PIXEL(src, x, y, 1) * 0xffff / 0xff);
         *dst_pixel++ = (uint16_t)((uint32_t)TILE_PIXEL(src, x, y, 2) * 0xffff / 0xff);
         *dst_pixel++ = (uint16_t)((uint32_t)TILE_PIXEL(src, x, y, 3) * 0xffff / 0xff);
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_r16_uscaled_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 2;
   uint16_t *dstpix = (uint16_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = (((uint16_t)(r[i+0] >> 8)) << 0);
            const uint32_t pixel1 = (((uint16_t)(r[i+1] >> 8)) << 0);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_r16g16_uscaled_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 4;
   uint32_t *dstpix = (uint32_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = (((uint16_t)(r[i+0] >> 8)) << 0) | (((uint16_t)(g[i+0] >> 8)) << 16);
            const uint32_t pixel1 = (((uint16_t)(r[i+1] >> 8)) << 0) | (((uint16_t)(g[i+1] >> 8)) << 16);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_r16g16b16_uscaled_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      uint16_t *dst_pixel = (uint16_t *)(dst_row + x0*6);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (uint16_t)(TILE_PIXEL(src, x, y, 0) >> 8);
         *dst_pixel++ = (uint16_t)(TILE_PIXEL(src, x, y, 1) >> 8);
         *dst_pixel++ = (uint16_t)(TILE_PIXEL(src, x, y, 2) >> 8);
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_r16g16b16a16_uscaled_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      uint16_t *dst_pixel = (uint16_t *)(dst_row + x0*8);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (uint16_t)(TILE_PIXEL(src, x, y, 0) >> 8);
         *dst_pixel++ = (uint16_t)(TILE_PIXEL(src, x, y, 1) >> 8);
         *dst_pixel++ = (uint16_t)(TILE_PIXEL(src, x, y, 2) >> 8);
         *dst_pixel++ = (uint16_t)(TILE_PIXEL(src, x, y, 3) >> 8);
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_r8_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 1;
   uint8_t *dstpix = (uint8_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = ((r[i+0]) << 0);
            const uint32_t pixel1 = ((r[i+1]) << 0);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_r8g8_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 2;
   uint16_t *dstpix = (uint16_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = ((r[i+0]) << 0) | ((g[i+0]) << 8);
            const uint32_t pixel1 = ((r[i+1]) << 0) | ((g[i+1]) << 8);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_r8g8b8_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      uint8_t *dst_pixel = (uint8_t *)(dst_row + x0*3);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = TILE_PIXEL(src, x, y, 0);
         *dst_pixel++ = TILE_PIXEL(src, x, y, 1);
         *dst_pixel++ = TILE_PIXEL(src, x, y, 2);
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_r8g8b8a8_unorm_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 4;
   uint32_t *dstpix = (uint32_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = ((r[i+0]) << 0) | ((g[i+0]) << 8) | ((b[i+0]) << 16) | ((a[i+0]) << 24);
            const uint32_t pixel1 = ((r[i+1]) << 0) | ((g[i+1]) << 8) | ((b[i+1]) << 16) | ((a[i+1]) << 24);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_r8_uscaled_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 1;
   uint8_t *dstpix = (uint8_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = (((uint8_t)(r[i+0] >> 8)) << 0);
            const uint32_t pixel1 = (((uint8_t)(r[i+1] >> 8)) << 0);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_r8g8_uscaled_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 2;
   uint16_t *dstpix = (uint16_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = (((uint8_t)(r[i+0] >> 8)) << 0) | (((uint8_t)(g[i+0] >> 8)) << 8);
            const uint32_t pixel1 = (((uint8_t)(r[i+1] >> 8)) << 0) | (((uint8_t)(g[i+1] >> 8)) << 8);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

static void
lp_tile_r8g8b8_uscaled_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   unsigned x, y;
   uint8_t *dst_row = dst + y0*dst_stride;
   for (y = 0; y < h; ++y) {
      uint8_t *dst_pixel = (uint8_t *)(dst_row + x0*3);
      for (x = 0; x < w; ++x) {
         *dst_pixel++ = (uint8_t)(TILE_PIXEL(src, x, y, 0) >> 8);
         *dst_pixel++ = (uint8_t)(TILE_PIXEL(src, x, y, 1) >> 8);
         *dst_pixel++ = (uint8_t)(TILE_PIXEL(src, x, y, 2) >> 8);
      }
      dst_row += dst_stride;
   }
}

static void
lp_tile_r8g8b8a8_uscaled_write_4ub(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h)
{
   const unsigned dstpix_stride = dst_stride / 4;
   uint32_t *dstpix = (uint32_t *) dst;
   unsigned int qx, qy, i;

   for (qy = 0; qy < h; qy += TILE_VECTOR_HEIGHT) {
      const unsigned py = y0 + qy;
      for (qx = 0; qx < w; qx += TILE_VECTOR_WIDTH) {
         const unsigned px = x0 + qx;
         const uint8_t *r = src + 0 * TILE_C_STRIDE;
         const uint8_t *g = src + 1 * TILE_C_STRIDE;
         const uint8_t *b = src + 2 * TILE_C_STRIDE;
         const uint8_t *a = src + 3 * TILE_C_STRIDE;
         (void) r; (void) g; (void) b; (void) a; /* silence warnings */
         for (i = 0; i < TILE_C_STRIDE; i += 2) {
            const uint32_t pixel0 = (((uint8_t)(r[i+0] >> 8)) << 0) | (((uint8_t)(g[i+0] >> 8)) << 8) | (((uint8_t)(b[i+0] >> 8)) << 16) | (((uint8_t)(a[i+0] >> 8)) << 24);
            const uint32_t pixel1 = (((uint8_t)(r[i+1] >> 8)) << 0) | (((uint8_t)(g[i+1] >> 8)) << 8) | (((uint8_t)(b[i+1] >> 8)) << 16) | (((uint8_t)(a[i+1] >> 8)) << 24);
            const unsigned offset = (py + tile_y_offset[i]) * dstpix_stride + (px + tile_x_offset[i]);
            dstpix[offset + 0] = pixel0;
            dstpix[offset + 1] = pixel1;
         }
         src += TILE_X_STRIDE;
      }
   }
}

void
lp_tile_write_4ub(enum pipe_format format, const uint8_t *src, void *dst, unsigned dst_stride, unsigned x, unsigned y, unsigned w, unsigned h)
{
   void (*func)(const uint8_t *src, uint8_t *dst, unsigned dst_stride, unsigned x0, unsigned y0, unsigned w, unsigned h);
   switch(format) {
   case PIPE_FORMAT_B8G8R8A8_UNORM:
      func = &lp_tile_b8g8r8a8_unorm_write_4ub;
      break;
   case PIPE_FORMAT_B8G8R8X8_UNORM:
      func = &lp_tile_b8g8r8x8_unorm_write_4ub;
      break;
   case PIPE_FORMAT_A8R8G8B8_UNORM:
      func = &lp_tile_a8r8g8b8_unorm_write_4ub;
      break;
   case PIPE_FORMAT_X8R8G8B8_UNORM:
      func = &lp_tile_x8r8g8b8_unorm_write_4ub;
      break;
   case PIPE_FORMAT_A8B8G8R8_UNORM:
      func = &lp_tile_a8b8g8r8_unorm_write_4ub;
      break;
   case PIPE_FORMAT_X8B8G8R8_UNORM:
      func = &lp_tile_x8b8g8r8_unorm_write_4ub;
      break;
   case PIPE_FORMAT_B5G5R5A1_UNORM:
      func = &lp_tile_b5g5r5a1_unorm_write_4ub;
      break;
   case PIPE_FORMAT_B4G4R4A4_UNORM:
      func = &lp_tile_b4g4r4a4_unorm_write_4ub;
      break;
   case PIPE_FORMAT_B5G6R5_UNORM:
      func = &lp_tile_b5g6r5_unorm_write_4ub;
      break;
   case PIPE_FORMAT_R10G10B10A2_UNORM:
      func = &lp_tile_r10g10b10a2_unorm_write_4ub;
      break;
   case PIPE_FORMAT_L8_UNORM:
      func = &lp_tile_l8_unorm_write_4ub;
      break;
   case PIPE_FORMAT_A8_UNORM:
      func = &lp_tile_a8_unorm_write_4ub;
      break;
   case PIPE_FORMAT_I8_UNORM:
      func = &lp_tile_i8_unorm_write_4ub;
      break;
   case PIPE_FORMAT_L8A8_UNORM:
      func = &lp_tile_l8a8_unorm_write_4ub;
      break;
   case PIPE_FORMAT_L16_UNORM:
      func = &lp_tile_l16_unorm_write_4ub;
      break;
   case PIPE_FORMAT_Z16_UNORM:
      func = &lp_tile_z16_unorm_write_4ub;
      break;
   case PIPE_FORMAT_Z32_UNORM:
      func = &lp_tile_z32_unorm_write_4ub;
      break;
   case PIPE_FORMAT_Z32_FLOAT:
      func = &lp_tile_z32_float_write_4ub;
      break;
   case PIPE_FORMAT_Z24S8_UNORM:
      func = &lp_tile_z24s8_unorm_write_4ub;
      break;
   case PIPE_FORMAT_S8Z24_UNORM:
      func = &lp_tile_s8z24_unorm_write_4ub;
      break;
   case PIPE_FORMAT_Z24X8_UNORM:
      func = &lp_tile_z24x8_unorm_write_4ub;
      break;
   case PIPE_FORMAT_X8Z24_UNORM:
      func = &lp_tile_x8z24_unorm_write_4ub;
      break;
   case PIPE_FORMAT_R64_FLOAT:
      func = &lp_tile_r64_float_write_4ub;
      break;
   case PIPE_FORMAT_R64G64_FLOAT:
      func = &lp_tile_r64g64_float_write_4ub;
      break;
   case PIPE_FORMAT_R64G64B64_FLOAT:
      func = &lp_tile_r64g64b64_float_write_4ub;
      break;
   case PIPE_FORMAT_R64G64B64A64_FLOAT:
      func = &lp_tile_r64g64b64a64_float_write_4ub;
      break;
   case PIPE_FORMAT_R32_FLOAT:
      func = &lp_tile_r32_float_write_4ub;
      break;
   case PIPE_FORMAT_R32G32_FLOAT:
      func = &lp_tile_r32g32_float_write_4ub;
      break;
   case PIPE_FORMAT_R32G32B32_FLOAT:
      func = &lp_tile_r32g32b32_float_write_4ub;
      break;
   case PIPE_FORMAT_R32G32B32A32_FLOAT:
      func = &lp_tile_r32g32b32a32_float_write_4ub;
      break;
   case PIPE_FORMAT_R32_UNORM:
      func = &lp_tile_r32_unorm_write_4ub;
      break;
   case PIPE_FORMAT_R32G32_UNORM:
      func = &lp_tile_r32g32_unorm_write_4ub;
      break;
   case PIPE_FORMAT_R32G32B32_UNORM:
      func = &lp_tile_r32g32b32_unorm_write_4ub;
      break;
   case PIPE_FORMAT_R32G32B32A32_UNORM:
      func = &lp_tile_r32g32b32a32_unorm_write_4ub;
      break;
   case PIPE_FORMAT_R32_USCALED:
      func = &lp_tile_r32_uscaled_write_4ub;
      break;
   case PIPE_FORMAT_R32G32_USCALED:
      func = &lp_tile_r32g32_uscaled_write_4ub;
      break;
   case PIPE_FORMAT_R32G32B32_USCALED:
      func = &lp_tile_r32g32b32_uscaled_write_4ub;
      break;
   case PIPE_FORMAT_R32G32B32A32_USCALED:
      func = &lp_tile_r32g32b32a32_uscaled_write_4ub;
      break;
   case PIPE_FORMAT_R16_UNORM:
      func = &lp_tile_r16_unorm_write_4ub;
      break;
   case PIPE_FORMAT_R16G16_UNORM:
      func = &lp_tile_r16g16_unorm_write_4ub;
      break;
   case PIPE_FORMAT_R16G16B16_UNORM:
      func = &lp_tile_r16g16b16_unorm_write_4ub;
      break;
   case PIPE_FORMAT_R16G16B16A16_UNORM:
      func = &lp_tile_r16g16b16a16_unorm_write_4ub;
      break;
   case PIPE_FORMAT_R16_USCALED:
      func = &lp_tile_r16_uscaled_write_4ub;
      break;
   case PIPE_FORMAT_R16G16_USCALED:
      func = &lp_tile_r16g16_uscaled_write_4ub;
      break;
   case PIPE_FORMAT_R16G16B16_USCALED:
      func = &lp_tile_r16g16b16_uscaled_write_4ub;
      break;
   case PIPE_FORMAT_R16G16B16A16_USCALED:
      func = &lp_tile_r16g16b16a16_uscaled_write_4ub;
      break;
   case PIPE_FORMAT_R8_UNORM:
      func = &lp_tile_r8_unorm_write_4ub;
      break;
   case PIPE_FORMAT_R8G8_UNORM:
      func = &lp_tile_r8g8_unorm_write_4ub;
      break;
   case PIPE_FORMAT_R8G8B8_UNORM:
      func = &lp_tile_r8g8b8_unorm_write_4ub;
      break;
   case PIPE_FORMAT_R8G8B8A8_UNORM:
      func = &lp_tile_r8g8b8a8_unorm_write_4ub;
      break;
   case PIPE_FORMAT_R8_USCALED:
      func = &lp_tile_r8_uscaled_write_4ub;
      break;
   case PIPE_FORMAT_R8G8_USCALED:
      func = &lp_tile_r8g8_uscaled_write_4ub;
      break;
   case PIPE_FORMAT_R8G8B8_USCALED:
      func = &lp_tile_r8g8b8_uscaled_write_4ub;
      break;
   case PIPE_FORMAT_R8G8B8A8_USCALED:
      func = &lp_tile_r8g8b8a8_uscaled_write_4ub;
      break;
   default:
      debug_printf("unsupported format\n");
      return;
   }
   func(src, (uint8_t *)dst, dst_stride, x, y, w, h);
}

